	/*****************************************************************
 * PTlink Services is (C) CopyRight PTlink Coders Team 1999-2002 *
 * http://www.ptlink.net/Coders/ - coders@PTlink.net             *
 * This program is distributed under GNU Public License          *
 * Please read the file COPYING for copyright information.       *
 *****************************************************************
*/ 
#include "ircdsetup.h"
#include "messages.h"
#include "language.h"
#include "services.h"
#include "strcache.h"

/* The list of lists of messages. */
extern char **langtexts[NUM_LANGS];
int lang_scs[NUM_LANGS][NUM_STRINGS];
int scs_list[SCS_SIZE];
int cache_count = 0;

/* 
 * RETURN
 *   the number of messages we can cache
 *   (Note: messages using % format values cannot be
 *     sent on the actual SCS protocol ) 
 */
int init_scs_cache(void)
{
  int l,i;
  int id = 0;
  char buf[4096];  
  char *s, *t;
  
  for (l = 0; l < NUM_LANGS; l++)
    {
      for (i =0 ; i < NUM_STRINGS; i++)
          {
            s = langtexts[l][i];
            lang_scs[l][i]= id;
            if(!s)
            	continue;
            
            strcpy(buf, s);
            s = buf;            
            while (*s) 
              {
                t = s;
                s += strcspn(s, "\n");
                if (*s)
                  *s++ = 0;
                if(strchr(t,'%'))
                  continue;
                id++;
	          }
      	  }
    }  
    
   cache_count = id;
   return id;
}
/*
 * m_scs_chk - cache check
 *      av[0] = time
 *      av[1] = count
 */

void m_scschk(char *source, int ac, char **av) 
{
  time_t new_ts;
  int l,i;
  int id = 0;
  char *s,*t;
  char buf[4096];
  
  if(ac != 2)
    return;
 
  new_ts = atol(av[0]);
  if(SCS_TS == new_ts) /* cache is up to date */
    return;
    
   log2("Starting SCS upload...");
   for (l = 0; l < NUM_LANGS; l++)
     {
        log2("SCS upload for lang %i, [%i]",l
         	,id);
        for (i =0 ; i < NUM_STRINGS; i++)
          {
            s = langtexts[l][i];
            if(!s)
            	continue;
            
            strcpy(buf, s);
            s = buf;            
            while (*s) 
              {
                t = s;
                s += strcspn(s, "\n");
                if (*s)
                  *s++ = 0;
                  
                if(strchr(t,'%'))
                  continue;
                send_cmd(NULL,"SCSSET %d %d :%s",
      	          SCS_TS, id++, *t ? t : " ");
	          }
      	  }
     }
   log2("SCS upload done.");
}
